<?php

global $user, $template, $lang, $conf, $page;

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

include_once(NBC_NEWS_PATH.'include/constants.php');
include_once(NBC_NEWS_PATH.'include/functions_news.inc.php');
include(get_language_filepath('plugin.lang.php', NBC_NEWS_PATH));
  


// Gestion des onglets
include_once(PHPWG_ROOT_PATH . 'admin/include/functions_tabsheet.inc.php');

$page['tab'] = 'Groups';

$page_news_admin = get_admin_plugin_menu_link(dirname(__FILE__).'/news_admin.php');

$page['tabsheet'] = array(
    'NewsAdmin' => array('caption' => l10n('title_admin_news'), 'url' => add_url_params($page_news_admin, array('tab' => 'NewsAdmin'))),
    'Users' => array('caption' => l10n('title_users'), 'url' => add_url_params($page_news_admin, array('tab' => 'Users'))),
    'Groups' => array('caption' => l10n('title_groups'), 'url' => add_url_params($page_news_admin, array('tab' => 'Groups'))),
    'Config' => array('caption' => l10n('config'), 'url' => add_url_params($page_news_admin, array('tab' => 'Config'))),
    );

$page['tabsheet'][$page['tab']]['selected'] = true;
template_assign_tabsheet();


  
include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');

// +-----------------------------------------------------------------------+
// | Check Access and exit when user status is not ok                      |
// +-----------------------------------------------------------------------+
check_status(ACCESS_ADMINISTRATOR);

// +-----------------------------------------------------------------------+
// |                            variables init                             |
// +-----------------------------------------------------------------------+

if (isset($_GET['group_id']) and is_numeric($_GET['group_id']))
{
  $page['group'] = $_GET['group_id'];
}
else
{
  echo l10n('group_id URL parameter is missing');
  exit();
}


// +-----------------------------------------------------------------------+
// |                                updates                                |
// +-----------------------------------------------------------------------+

if (isset($_POST['falsify']) and isset($_POST['news_true']) and count($_POST['news_true']) > 0 and !is_adviser() )
{
  // if you forbid access to a news
  $query = '
    DELETE FROM '.NEWS_GROUP_ACCESS_TABLE.'
    WHERE group_id = '.$page['group'].'
    AND new_id IN ('.implode(',', $_POST['news_true']).')
    ;';
  
  pwg_query($query);
}
else if (isset($_POST['falsify']) and isset($_POST['news_refuse']) and count($_POST['news_refuse']) > 0 and !is_adviser() )
{
  // if you forbid access to a news
  $query = '
    DELETE FROM '.NEWS_GROUP_REFUSED_TABLE.'
    WHERE group_id = '.$page['group'].'
    AND new_id IN ('.implode(',', $_POST['news_refuse']).')
    ;';
  
  pwg_query($query);
}
else if (isset($_POST['trueify']) and isset($_POST['news_false']) and count($_POST['news_false']) > 0 and !is_adviser() )
{
  $inserts = array();

  foreach ($_POST['news_false'] as $to_autorize_id)
  {
    array_push($inserts, array('group_id' => $page['group'],
                               'new_id' => $to_autorize_id));
  }

  mass_inserts(NEWS_GROUP_ACCESS_TABLE, array('group_id','new_id'), $inserts);
}
else if (isset($_POST['refusify']) and isset($_POST['news_false']) and count($_POST['news_false']) > 0 and !is_adviser() )
{
  $inserts = array();

  foreach ($_POST['news_false'] as $to_refuse_id)
  {
    array_push($inserts, array('group_id' => $page['group'],
                               'new_id' => $to_refuse_id));
  }

  mass_inserts(NEWS_GROUP_REFUSED_TABLE, array('group_id','new_id'), $inserts);
}


// +-----------------------------------------------------------------------+
// |                             template init                             |
// +-----------------------------------------------------------------------+

$template->set_filenames(
  array(
    'news_admin_perm' => NBC_NEWS_PATH . 'template/admin/news_admin_perm.tpl',
    'news_double_select' => NBC_NEWS_PATH . 'template/admin/news_double_select.tpl'
    )
  );

$template->assign_vars(
  array(
    'TITLE' => sprintf(l10n('Manage permissions for group "%s"'), get_groupname($page['group'])),
    'U_HELP' => PHPWG_ROOT_PATH.'popuphelp.php?page=news_group_perm',
    'F_ACTION' => add_url_params(get_admin_plugin_menu_link(dirname(__FILE__).'/news_group_perm.php'), array('group_id' => $page['group'])), 
  )
);

// only private news are listed
$query_refuse = '
  SELECT nt.id, nt.title, nt.new_id
  FROM '.NEWS_TRANSLATION_TABLE.' as nt 
  INNER JOIN '.NEWS_GROUP_REFUSED_TABLE.' as ngd ON nt.new_id = ngd.new_id
  INNER JOIN '.NEWS_TABLE.' as n ON n.id = nt.new_id
  WHERE n.status = \'private\'
  AND ngd.group_id = '.$page['group'].'
  ORDER BY nt.new_id;';
  
display_select_news_wrapper($query_refuse,array(),'news_option_refuse');

$result = pwg_query($query_refuse);

$refused_ids = array();

while ($row = mysql_fetch_array($result))
{
  array_push($refused_ids, $row['new_id']);
}

$query_true = '
  SELECT nt.id, nt.title, nt.new_id
  FROM '.NEWS_TRANSLATION_TABLE.' as nt 
  INNER JOIN '.NEWS_GROUP_ACCESS_TABLE.' as nga ON nt.new_id = nga.new_id
  INNER JOIN '.NEWS_TABLE.' as n ON n.id = nt.new_id
  WHERE n.status = \'private\'
  AND nga.group_id = '.$page['group'];
$query_true .= (count($refused_ids) > 0) ? ' AND nt.new_id NOT IN ('.implode(',', $refused_ids).')' : '';
$query_true .= ' ORDER BY nt.new_id;';

display_select_news_wrapper($query_true,array(),'news_option_true');

$result = pwg_query($query_true);

$authorized_ids = array();

while ($row = mysql_fetch_array($result))
{
  array_push($authorized_ids, $row['new_id']);
}


$query_false = '
  SELECT nt.id, nt.title, nt.new_id
  FROM '.NEWS_TRANSLATION_TABLE.' as nt
  INNER JOIN '.NEWS_TABLE.' as n ON n.id = nt.new_id
  WHERE n.status = \'private\'';
$query_false.= (count($refused_ids) > 0) ? ' AND nt.new_id NOT IN ('.implode(',', $refused_ids).')': '';
$query_false.= (count($authorized_ids) > 0)? ' AND nt.new_id NOT IN ('.implode(',', $authorized_ids).')' : '';
$query_false.= ' ORDER BY nt.new_id;';

display_select_news_wrapper($query_false,array(),'news_option_false');


// +-----------------------------------------------------------------------+
// |                           html code display                           |
// +-----------------------------------------------------------------------+

$template->assign_var_from_handle('NEWS_DOUBLE_SELECT', 'news_double_select');
$template->assign_var_from_handle('ADMIN_CONTENT', 'news_admin_perm');

?>
